import{S as Br,i as Kr,s as Gr,e as l,k as h,w as f,t as e,M as Jr,c as o,d as t,m as d,a as r,x as m,h as n,b as c,G as a,g as i,y as g,q as b,o as y,B as j,v as Qr}from"../chunks/vendor-hf-doc-builder.js";import{T as Vr}from"../chunks/Tip-hf-doc-builder.js";import{I as gs}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as S}from"../chunks/CodeBlock-hf-doc-builder.js";function Xr(ut){let w,ss,$,P,B;return{c(){w=l("p"),ss=e("A "),$=l("a"),P=e("Dataset"),B=e(" object is a wrapper of an Arrow table, which allows fast reads from arrays in the dataset to TensorFlow tensors."),this.h()},l(A){w=o(A,"P",{});var H=r(w);ss=n(H,"A "),$=o(H,"A",{href:!0});var as=r($);P=n(as,"Dataset"),as.forEach(t),B=n(H," object is a wrapper of an Arrow table, which allows fast reads from arrays in the dataset to TensorFlow tensors."),H.forEach(t),this.h()},h(){c($,"href","/docs/datasets/v2.9.0/en/package_reference/main_classes#datasets.Dataset")},m(A,H){i(A,w,H),a(w,ss),a(w,$),a($,P),a(w,B)},d(A){A&&t(w)}}}function Zr(ut){let w,ss,$,P,B,A,H,as,fe,ft,T,me,na,ge,be,la,ye,je,oa,we,ve,ra,_e,Ee,mt,K,ts,pa,bs,$e,ia,De,gt,Ws,ke,bt,es,Te,ha,qe,xe,yt,ys,jt,ns,wt,L,Ce,da,Ae,Oe,ca,Pe,Fe,vt,js,_t,G,ls,ua,ws,Ie,fa,Ne,Et,os,Se,ma,He,Le,$t,vs,Dt,Ms,Ue,kt,_s,Tt,J,rs,ga,Es,Ye,ba,Re,qt,$s,zs,We,Me,xt,Ds,Ct,Bs,ze,At,ks,Ot,Ks,Be,Pt,Ts,Ft,Gs,Ke,It,U,Ge,Js,Je,Qe,Qs,Ve,Xe,Nt,qs,St,xs,Ht,Q,ps,ya,Cs,Ze,ja,sn,Lt,D,an,wa,tn,en,va,nn,ln,_a,on,rn,Ea,pn,hn,$a,dn,cn,Ut,v,un,Da,fn,mn,ka,gn,bn,Ta,yn,jn,qa,wn,vn,xa,_n,En,Ca,$n,Dn,Yt,_,kn,Aa,Tn,qn,Oa,xn,Cn,Pa,An,On,As,Pn,Fn,Os,In,Nn,Fa,Sn,Hn,Rt,V,is,Ia,Ps,Ln,Vs,Un,Na,Yn,Wt,hs,Rn,Sa,Wn,Mn,Mt,Fs,zt,F,zn,Ha,Bn,Kn,La,Gn,Jn,Ua,Qn,Vn,Bt,Is,Kt,E,Xn,Xs,Zn,sl,Ya,al,tl,Ns,el,nl,Ra,ll,ol,Ss,rl,pl,Hs,il,hl,Gt,Y,dl,Wa,cl,ul,Ma,fl,ml,Jt,X,ds,za,Ls,gl,Ba,bl,Qt,u,yl,Ka,jl,wl,Ga,vl,_l,Ja,El,$l,Qa,Dl,kl,Va,Tl,ql,Xa,xl,Cl,Za,Al,Ol,Vt,R,Pl,st,Fl,Il,at,Nl,Sl,Xt,W,Us,Hl,tt,Ll,Ul,Yl,N,Rl,et,Wl,Ml,nt,zl,Bl,lt,Kl,Gl,Jl,O,Ql,ot,Vl,Xl,rt,Zl,so,pt,ao,to,it,eo,no,Zt,Z,cs,ht,Ys,lo,dt,oo,se,us,ro,ct,po,io,ae;return A=new gs({}),bs=new gs({}),ys=new S({props:{code:`from datasets import Dataset
data = [[1, 2],[3, 4]]
ds = Dataset.from_dict({"data": [[1, 2],[3, 4]]})
ds = ds.with_format("tf")
ds[0]
ds[:2]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset
<span class="hljs-meta">&gt;&gt;&gt; </span>data = [[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],[<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]]
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;data&quot;</span>: [[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],[<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]]})
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>,), dtype=int64, numpy=array([<span class="hljs-number">1</span>, <span class="hljs-number">2</span>])&gt;}
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:<span class="hljs-number">2</span>]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>), dtype=int64, numpy=
array([[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],
       [<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]])&gt;}`}}),ns=new Vr({props:{$$slots:{default:[Xr]},$$scope:{ctx:ut}}}),js=new S({props:{code:"ds[:]",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>), dtype=int64, numpy=
array([[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],
       [<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]])&gt;}`}}),ws=new gs({}),vs=new S({props:{code:`from datasets import Dataset
data = [[[1, 2],[3, 4]],[[5, 6],[7, 8]]]
ds = Dataset.from_dict({"data": data})
ds = ds.with_format("tf")
ds[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset
<span class="hljs-meta">&gt;&gt;&gt; </span>data = [[[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],[<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]],[[<span class="hljs-number">5</span>, <span class="hljs-number">6</span>],[<span class="hljs-number">7</span>, <span class="hljs-number">8</span>]]]
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;data&quot;</span>: data})
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.RaggedTensor [[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>], [<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]]&gt;}`}}),_s=new S({props:{code:`from datasets import Dataset, Features, Array2D
data = [[[1, 2],[3, 4]],[[5, 6],[7, 8]]]
features = Features({"data": Array2D(shape=(2, 2), dtype='int32')})
ds = Dataset.from_dict({"data": data}, features=features)
ds = ds.with_format("tf")
ds[0]
ds[:2]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset, Features, Array2D
<span class="hljs-meta">&gt;&gt;&gt; </span>data = [[[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],[<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]],[[<span class="hljs-number">5</span>, <span class="hljs-number">6</span>],[<span class="hljs-number">7</span>, <span class="hljs-number">8</span>]]]
<span class="hljs-meta">&gt;&gt;&gt; </span>features = Features({<span class="hljs-string">&quot;data&quot;</span>: Array2D(shape=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>), dtype=<span class="hljs-string">&#x27;int32&#x27;</span>)})
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;data&quot;</span>: data}, features=features)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>), dtype=int64, numpy=
 array([[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],
        [<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]])&gt;}
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:<span class="hljs-number">2</span>]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>, <span class="hljs-number">2</span>), dtype=int64, numpy=
 array([[[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],
         [<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]],
 
        [[<span class="hljs-number">5</span>, <span class="hljs-number">6</span>],
         [<span class="hljs-number">7</span>, <span class="hljs-number">8</span>]]])&gt;}`}}),Es=new gs({}),Ds=new S({props:{code:`from datasets import Dataset, Features, ClassLabel
labels = [0, 0, 1]
features = Features({"label": ClassLabel(names=["negative", "positive"])})
ds = Dataset.from_dict({"label": labels}, features=features) 
ds = ds.with_format("tf")  
ds[:3]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset, Features, ClassLabel
<span class="hljs-meta">&gt;&gt;&gt; </span>labels = [<span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">1</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>features = Features({<span class="hljs-string">&quot;label&quot;</span>: ClassLabel(names=[<span class="hljs-string">&quot;negative&quot;</span>, <span class="hljs-string">&quot;positive&quot;</span>])})
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;label&quot;</span>: labels}, features=features) 
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>)  
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:<span class="hljs-number">3</span>]
{<span class="hljs-string">&#x27;label&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">3</span>,), dtype=int64, numpy=array([<span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">1</span>])&gt;}`}}),ks=new S({props:{code:`from datasets import Dataset, Features 
text = ["foo", "bar"]
data = [0, 1] 
ds = Dataset.from_dict({"text": text, "data": data})  
ds = ds.with_format("tf") 
ds[:2]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset, Features 
<span class="hljs-meta">&gt;&gt;&gt; </span>text = [<span class="hljs-string">&quot;foo&quot;</span>, <span class="hljs-string">&quot;bar&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>data = [<span class="hljs-number">0</span>, <span class="hljs-number">1</span>] 
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;text&quot;</span>: text, <span class="hljs-string">&quot;data&quot;</span>: data})  
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>) 
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:<span class="hljs-number">2</span>]
{<span class="hljs-string">&#x27;text&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>,), dtype=string, numpy=array([<span class="hljs-string">b&#x27;foo&#x27;</span>, <span class="hljs-string">b&#x27;bar&#x27;</span>], dtype=<span class="hljs-built_in">object</span>)&gt;,
 <span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>,), dtype=int64, numpy=array([<span class="hljs-number">0</span>, <span class="hljs-number">1</span>])&gt;}`}}),Ts=new S({props:{code:`ds = ds.with_format("tf", columns=["data"], output_all_columns=True)
ds[:2]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>, columns=[<span class="hljs-string">&quot;data&quot;</span>], output_all_columns=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:<span class="hljs-number">2</span>]
{<span class="hljs-string">&#x27;data&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>,), dtype=int64, numpy=array([<span class="hljs-number">0</span>, <span class="hljs-number">1</span>])&gt;,
 <span class="hljs-string">&#x27;text&#x27;</span>: [<span class="hljs-string">&#x27;foo&#x27;</span>, <span class="hljs-string">&#x27;bar&#x27;</span>]}`}}),qs=new S({props:{code:`from datasets import Dataset, Features, Audio, Image
images = ["path/to/image.png"] * 10
features = Features({"image": Image()})
ds = Dataset.from_dict({"image": images}, features=features) 
ds = ds.with_format("tf")  
ds[0]
ds[:2]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset, Features, Audio, Image
<span class="hljs-meta">&gt;&gt;&gt; </span>images = [<span class="hljs-string">&quot;path/to/image.png&quot;</span>] * <span class="hljs-number">10</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>features = Features({<span class="hljs-string">&quot;image&quot;</span>: Image()})
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;image&quot;</span>: images}, features=features) 
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>)  
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;image&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">512</span>, <span class="hljs-number">512</span>, <span class="hljs-number">4</span>), dtype=uint8, numpy=
 array([[[<span class="hljs-number">255</span>, <span class="hljs-number">215</span>, <span class="hljs-number">106</span>, <span class="hljs-number">255</span>],
         [<span class="hljs-number">255</span>, <span class="hljs-number">215</span>, <span class="hljs-number">106</span>, <span class="hljs-number">255</span>],
         ...,
         [<span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>],
         [<span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>]]], dtype=uint8)&gt;}
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[:<span class="hljs-number">2</span>]
{<span class="hljs-string">&#x27;image&#x27;</span>: &lt;tf.Tensor: shape=(<span class="hljs-number">2</span>, <span class="hljs-number">512</span>, <span class="hljs-number">512</span>, <span class="hljs-number">4</span>), dtype=uint8, numpy=
 array([[[[<span class="hljs-number">255</span>, <span class="hljs-number">215</span>, <span class="hljs-number">106</span>, <span class="hljs-number">255</span>],
          [<span class="hljs-number">255</span>, <span class="hljs-number">215</span>, <span class="hljs-number">106</span>, <span class="hljs-number">255</span>],
          ...,
          [<span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>],
          [<span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>, <span class="hljs-number">255</span>]]]], dtype=uint8)&gt;}`}}),xs=new S({props:{code:`from datasets import Dataset, Features, Audio, Image
audio = ["path/to/audio.wav"] * 10
features = Features({"audio": Audio()})
ds = Dataset.from_dict({"audio": audio}, features=features) 
ds = ds.with_format("tf")  
ds[0]["audio"]["array"]
ds[0]["audio"]["sampling_rate"]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset, Features, Audio, Image
<span class="hljs-meta">&gt;&gt;&gt; </span>audio = [<span class="hljs-string">&quot;path/to/audio.wav&quot;</span>] * <span class="hljs-number">10</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>features = Features({<span class="hljs-string">&quot;audio&quot;</span>: Audio()})
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict({<span class="hljs-string">&quot;audio&quot;</span>: audio}, features=features) 
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = ds.with_format(<span class="hljs-string">&quot;tf&quot;</span>)  
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>]
&lt;tf.Tensor: shape=(<span class="hljs-number">202311</span>,), dtype=float32, numpy=
array([ <span class="hljs-number">6.1035156e-05</span>,  <span class="hljs-number">1.5258789e-05</span>,  <span class="hljs-number">1.6784668e-04</span>, ...,
       -<span class="hljs-number">1.5258789e-05</span>, -<span class="hljs-number">1.5258789e-05</span>,  <span class="hljs-number">1.5258789e-05</span>], dtype=float32)&gt;
<span class="hljs-meta">&gt;&gt;&gt; </span>ds[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;sampling_rate&quot;</span>]
&lt;tf.Tensor: shape=(), dtype=int32, numpy=<span class="hljs-number">44100</span>&gt;`}}),Cs=new gs({}),Ps=new gs({}),Fs=new S({props:{code:`from datasets import Dataset
data = {"inputs": [[1, 2],[3, 4]], "labels": [0, 1]}
ds = Dataset.from_dict(data)
tf_ds = ds.to_tf_dataset(`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset
<span class="hljs-meta">&gt;&gt;&gt; </span>data = {<span class="hljs-string">&quot;inputs&quot;</span>: [[<span class="hljs-number">1</span>, <span class="hljs-number">2</span>],[<span class="hljs-number">3</span>, <span class="hljs-number">4</span>]], <span class="hljs-string">&quot;labels&quot;</span>: [<span class="hljs-number">0</span>, <span class="hljs-number">1</span>]}
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_dict(data)
<span class="hljs-meta">&gt;&gt;&gt; </span>tf_ds = ds.to_tf_dataset(
            columns=[<span class="hljs-string">&quot;inputs&quot;</span>],
            label_cols=[<span class="hljs-string">&quot;labels&quot;</span>],
            batch_size=<span class="hljs-number">2</span>,
            shuffle=<span class="hljs-literal">True</span>
            )`}}),Is=new S({props:{code:"model.fit(tf_ds, epochs=2)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model.fit(tf_ds, epochs=<span class="hljs-number">2</span>)'}}),Ls=new gs({}),Ys=new gs({}),{c(){w=l("meta"),ss=h(),$=l("h1"),P=l("a"),B=l("span"),f(A.$$.fragment),H=h(),as=l("span"),fe=e("Using Datasets with TensorFlow"),ft=h(),T=l("p"),me=e("This document is a quick introduction to using "),na=l("code"),ge=e("datasets"),be=e(` with TensorFlow, with a particular focus on how to get
`),la=l("code"),ye=e("tf.Tensor"),je=e(" objects out of our datasets, and how to stream data from Hugging Face "),oa=l("code"),we=e("Dataset"),ve=e(` objects to Keras methods
like `),ra=l("code"),_e=e("model.fit()"),Ee=e("."),mt=h(),K=l("h2"),ts=l("a"),pa=l("span"),f(bs.$$.fragment),$e=h(),ia=l("span"),De=e("Dataset format"),gt=h(),Ws=l("p"),ke=e("By default, datasets return regular Python objects: integers, floats, strings, lists, etc."),bt=h(),es=l("p"),Te=e("To get TensorFlow tensors instead, you can set the format of the dataset to "),ha=l("code"),qe=e("tf"),xe=e(":"),yt=h(),f(ys.$$.fragment),jt=h(),f(ns.$$.fragment),wt=h(),L=l("p"),Ce=e("This can be useful for converting your dataset to a dict of "),da=l("code"),Ae=e("Tensor"),Oe=e(` objects, or for writing a generator to load TF
samples from it. If you wish to convert the entire dataset to `),ca=l("code"),Pe=e("Tensor"),Fe=e(", simply query the full dataset:"),vt=h(),f(js.$$.fragment),_t=h(),G=l("h2"),ls=l("a"),ua=l("span"),f(ws.$$.fragment),Ie=h(),fa=l("span"),Ne=e("N-dimensional arrays"),Et=h(),os=l("p"),Se=e(`If your dataset consists of N-dimensional arrays, you will see that by default they are considered as nested lists.
In particular, a TensorFlow formatted dataset outputs a `),ma=l("code"),He=e("RaggedTensor"),Le=e(" instead of a single tensor:"),$t=h(),f(vs.$$.fragment),Dt=h(),Ms=l("p"),Ue=e("To get a single tensor, you must explicitly use the Array feature type and specify the shape of your tensors:"),kt=h(),f(_s.$$.fragment),Tt=h(),J=l("h2"),rs=l("a"),ga=l("span"),f(Es.$$.fragment),Ye=h(),ba=l("span"),Re=e("Other feature types"),qt=h(),$s=l("p"),zs=l("a"),We=e("ClassLabel"),Me=e(" data are properly converted to tensors:"),xt=h(),f(Ds.$$.fragment),Ct=h(),Bs=l("p"),ze=e("Strings and binary objects are also supported:"),At=h(),f(ks.$$.fragment),Ot=h(),Ks=l("p"),Be=e("You can also explicitly format certain columns and leave the other columns unformatted:"),Pt=h(),f(Ts.$$.fragment),Ft=h(),Gs=l("p"),Ke=e("String and binary objects are unchanged, since PyTorch only supports numbers."),It=h(),U=l("p"),Ge=e("The "),Js=l("a"),Je=e("Image"),Qe=e(" and "),Qs=l("a"),Ve=e("Audio"),Xe=e(" feature types are also supported:"),Nt=h(),f(qs.$$.fragment),St=h(),f(xs.$$.fragment),Ht=h(),Q=l("h2"),ps=l("a"),ya=l("span"),f(Cs.$$.fragment),Ze=h(),ja=l("span"),sn=e("Data loading"),Lt=h(),D=l("p"),an=e(`Although you can load individual samples and batches just by indexing into your dataset, this won\u2019t work if you want
to use Keras methods like `),wa=l("code"),tn=e("fit()"),en=e(" and "),va=l("code"),nn=e("predict()"),ln=e(`. You could write a generator function that shuffles and loads batches
from your dataset and `),_a=l("code"),on=e("fit()"),rn=e(` on that, but that sounds like a lot of unnecessary work. Instead, if you want to stream
data from your dataset on-the-fly, we recommend converting your dataset to a `),Ea=l("code"),pn=e("tf.data.Dataset"),hn=e(` using the
`),$a=l("code"),dn=e("to_tf_dataset()"),cn=e(" method."),Ut=h(),v=l("p"),un=e("The "),Da=l("code"),fn=e("tf.data.Dataset"),mn=e(` class covers a wide range of use-cases - it is often created from Tensors in memory, or using a load function to read files on disc
or external storage. The dataset can be transformed arbitrarily with the `),ka=l("code"),gn=e("map()"),bn=e(" method, or methods like "),Ta=l("code"),yn=e("batch()"),jn=e(`
and `),qa=l("code"),wn=e("shuffle()"),vn=e(` can be used to create a dataset that\u2019s ready for training. These methods do not modify the stored data
in any way - instead, the methods build a data pipeline graph that will be executed when the dataset is iterated over,
usually during model training or inference. This is different from the `),xa=l("code"),_n=e("map()"),En=e(" method of Hugging Face "),Ca=l("code"),$n=e("Dataset"),Dn=e(` objects,
which runs the map function immediately and saves the new or changed columns.`),Yt=h(),_=l("p"),kn=e("Since the entire data preprocessing pipeline can be compiled in a "),Aa=l("code"),Tn=e("tf.data.Dataset"),qn=e(`, this approach allows for massively
parallel, asynchronous data loading and training. However, the requirement for graph compilation can be a limitation,
particularly for Hugging Face tokenizers, which are usually not (yet!) compilable as part of a TF graph. As a result,
we usually advise pre-processing the dataset as a Hugging Face dataset, where arbitrary Python functions can be
used, and then converting to `),Oa=l("code"),xn=e("tf.data.Dataset"),Cn=e(" afterwards using "),Pa=l("code"),An=e("to_tf_dataset()"),On=e(` to get a batched dataset ready for
training. To see examples of this approach, please see the `),As=l("a"),Pn=e("examples"),Fn=e(" or "),Os=l("a"),In=e("notebooks"),Nn=e(" for "),Fa=l("code"),Sn=e("transformers"),Hn=e("."),Rt=h(),V=l("h3"),is=l("a"),Ia=l("span"),f(Ps.$$.fragment),Ln=h(),Vs=l("span"),Un=e("Using "),Na=l("code"),Yn=e("to_tf_dataset()"),Wt=h(),hs=l("p"),Rn=e("Using "),Sa=l("code"),Wn=e("to_tf_dataset()"),Mn=e(" is straightforward. Once your dataset is preprocessed and ready, simply call it like so:"),Mt=h(),f(Fs.$$.fragment),zt=h(),F=l("p"),zn=e("The returned "),Ha=l("code"),Bn=e("tf_ds"),Kn=e(" object here is now fully ready to train on, and can be passed directly to "),La=l("code"),Gn=e("model.fit()"),Jn=e(`. Note
that you set the batch size when creating the dataset, and so you don\u2019t need to specify it when calling `),Ua=l("code"),Qn=e("fit()"),Vn=e(":"),Bt=h(),f(Is.$$.fragment),Kt=h(),E=l("p"),Xn=e("For a full description of the arguments, please see the "),Xs=l("a"),Zn=e("to_tf_dataset()"),sl=e(` documentation. In many cases,
you will also need to add a `),Ya=l("code"),al=e("collate_fn"),tl=e(` to your call. This is a function that takes multiple elements of the dataset
and combines them into a single batch. When all elements have the same length, the built-in default collator will
suffice, but for more complex tasks a custom collator may be necessary. In particular, many tasks have samples
with varying sequence lengths which will require a `),Ns=l("a"),el=e("data collator"),nl=e(` that can pad batches correctly. You can see examples
of this in the `),Ra=l("code"),ll=e("transformers"),ol=e(" NLP "),Ss=l("a"),rl=e("examples"),pl=e(` and
`),Hs=l("a"),il=e("notebooks"),hl=e(", where variable sequence lengths are very common."),Gt=h(),Y=l("p"),dl=e("If you find that loading with "),Wa=l("code"),cl=e("to_tf_dataset"),ul=e(" is slow, you can also use the "),Ma=l("code"),fl=e("num_workers"),ml=e(` argument. This spins
up multiple subprocesses to load data in parallel. This feature is recent and still somewhat experimental - please file
an issue if you encounter any bugs while using it!`),Jt=h(),X=l("h3"),ds=l("a"),za=l("span"),f(Ls.$$.fragment),gl=h(),Ba=l("span"),bl=e("When to use to_tf_dataset"),Qt=h(),u=l("p"),yl=e(`The astute reader may have noticed at this point that we have offered two approaches to achieve the same goal - if you
want to pass your dataset to a TensorFlow model, you can either convert the dataset to a `),Ka=l("code"),jl=e("Tensor"),wl=e(" or "),Ga=l("code"),vl=e("dict"),_l=e(" of "),Ja=l("code"),El=e("Tensors"),$l=e(`
using `),Qa=l("code"),Dl=e(".with_format('tf')"),kl=e(", or you can convert the dataset to a "),Va=l("code"),Tl=e("tf.data.Dataset"),ql=e(" with "),Xa=l("code"),xl=e("to_tf_dataset()"),Cl=e(`. Either of these
can be passed to `),Za=l("code"),Al=e("model.fit()"),Ol=e(", so which should you choose?"),Vt=h(),R=l("p"),Pl=e("The key thing to recognize is that when you convert the whole dataset to "),st=l("code"),Fl=e("Tensor"),Il=e(`s, it is static and fully loaded into
RAM. This is simple and convenient, but if any of the following apply, you should probably use `),at=l("code"),Nl=e("to_tf_dataset()"),Sl=e(`
instead:`),Xt=h(),W=l("ul"),Us=l("li"),Hl=e("Your dataset is too large to fit in RAM. "),tt=l("code"),Ll=e("to_tf_dataset()"),Ul=e(` streams only one batch at a time, so even very large
datasets can be handled with this method.`),Yl=h(),N=l("li"),Rl=e("You want to apply random transformations using "),et=l("code"),Wl=e("dataset.with_transform()"),Ml=e(" or the "),nt=l("code"),zl=e("collate_fn"),Bl=e(`. This is
common in several modalities, such as image augmentations when training vision models, or random masking when training
masked language models. Using `),lt=l("code"),Kl=e("to_tf_dataset()"),Gl=e(` will apply those transformations
at the moment when a batch is loaded, which means the same samples will get different augmentations each time
they are loaded. This is usually what you want.`),Jl=h(),O=l("li"),Ql=e(`Your data has a variable dimension, such as input texts in NLP that consist of varying
numbers of tokens. When you create a batch with samples with a variable dimension, the standard solution is to
pad the shorter samples to the length of the longest one. When you stream samples from a dataset with `),ot=l("code"),Vl=e("to_tf_dataset"),Xl=e(`,
you can apply this padding to each batch via your `),rt=l("code"),Zl=e("collate_fn"),so=e(`. However, if you want to convert
such a dataset to dense `),pt=l("code"),ao=e("Tensor"),to=e("s, then you will have to pad samples to the length of the longest sample in "),it=l("em"),eo=e(`the
entire dataset!`),no=e(" This can result in huge amounts of padding, which wastes memory and reduces your model\u2019s speed."),Zt=h(),Z=l("h3"),cs=l("a"),ht=l("span"),f(Ys.$$.fragment),lo=h(),dt=l("span"),oo=e("Caveats and limitations"),se=h(),us=l("p"),ro=e("Right now, "),ct=l("code"),po=e("to_tf_dataset()"),io=e(" always returns a batched dataset - we will add support for unbatched datasets soon!"),this.h()},l(s){const p=Jr('[data-svelte="svelte-1phssyn"]',document.head);w=o(p,"META",{name:!0,content:!0}),p.forEach(t),ss=d(s),$=o(s,"H1",{class:!0});var Rs=r($);P=o(Rs,"A",{id:!0,class:!0,href:!0});var uo=r(P);B=o(uo,"SPAN",{});var fo=r(B);m(A.$$.fragment,fo),fo.forEach(t),uo.forEach(t),H=d(Rs),as=o(Rs,"SPAN",{});var mo=r(as);fe=n(mo,"Using Datasets with TensorFlow"),mo.forEach(t),Rs.forEach(t),ft=d(s),T=o(s,"P",{});var M=r(T);me=n(M,"This document is a quick introduction to using "),na=o(M,"CODE",{});var go=r(na);ge=n(go,"datasets"),go.forEach(t),be=n(M,` with TensorFlow, with a particular focus on how to get
`),la=o(M,"CODE",{});var bo=r(la);ye=n(bo,"tf.Tensor"),bo.forEach(t),je=n(M," objects out of our datasets, and how to stream data from Hugging Face "),oa=o(M,"CODE",{});var yo=r(oa);we=n(yo,"Dataset"),yo.forEach(t),ve=n(M,` objects to Keras methods
like `),ra=o(M,"CODE",{});var jo=r(ra);_e=n(jo,"model.fit()"),jo.forEach(t),Ee=n(M,"."),M.forEach(t),mt=d(s),K=o(s,"H2",{class:!0});var te=r(K);ts=o(te,"A",{id:!0,class:!0,href:!0});var wo=r(ts);pa=o(wo,"SPAN",{});var vo=r(pa);m(bs.$$.fragment,vo),vo.forEach(t),wo.forEach(t),$e=d(te),ia=o(te,"SPAN",{});var _o=r(ia);De=n(_o,"Dataset format"),_o.forEach(t),te.forEach(t),gt=d(s),Ws=o(s,"P",{});var Eo=r(Ws);ke=n(Eo,"By default, datasets return regular Python objects: integers, floats, strings, lists, etc."),Eo.forEach(t),bt=d(s),es=o(s,"P",{});var ee=r(es);Te=n(ee,"To get TensorFlow tensors instead, you can set the format of the dataset to "),ha=o(ee,"CODE",{});var $o=r(ha);qe=n($o,"tf"),$o.forEach(t),xe=n(ee,":"),ee.forEach(t),yt=d(s),m(ys.$$.fragment,s),jt=d(s),m(ns.$$.fragment,s),wt=d(s),L=o(s,"P",{});var Zs=r(L);Ce=n(Zs,"This can be useful for converting your dataset to a dict of "),da=o(Zs,"CODE",{});var Do=r(da);Ae=n(Do,"Tensor"),Do.forEach(t),Oe=n(Zs,` objects, or for writing a generator to load TF
samples from it. If you wish to convert the entire dataset to `),ca=o(Zs,"CODE",{});var ko=r(ca);Pe=n(ko,"Tensor"),ko.forEach(t),Fe=n(Zs,", simply query the full dataset:"),Zs.forEach(t),vt=d(s),m(js.$$.fragment,s),_t=d(s),G=o(s,"H2",{class:!0});var ne=r(G);ls=o(ne,"A",{id:!0,class:!0,href:!0});var To=r(ls);ua=o(To,"SPAN",{});var qo=r(ua);m(ws.$$.fragment,qo),qo.forEach(t),To.forEach(t),Ie=d(ne),fa=o(ne,"SPAN",{});var xo=r(fa);Ne=n(xo,"N-dimensional arrays"),xo.forEach(t),ne.forEach(t),Et=d(s),os=o(s,"P",{});var le=r(os);Se=n(le,`If your dataset consists of N-dimensional arrays, you will see that by default they are considered as nested lists.
In particular, a TensorFlow formatted dataset outputs a `),ma=o(le,"CODE",{});var Co=r(ma);He=n(Co,"RaggedTensor"),Co.forEach(t),Le=n(le," instead of a single tensor:"),le.forEach(t),$t=d(s),m(vs.$$.fragment,s),Dt=d(s),Ms=o(s,"P",{});var Ao=r(Ms);Ue=n(Ao,"To get a single tensor, you must explicitly use the Array feature type and specify the shape of your tensors:"),Ao.forEach(t),kt=d(s),m(_s.$$.fragment,s),Tt=d(s),J=o(s,"H2",{class:!0});var oe=r(J);rs=o(oe,"A",{id:!0,class:!0,href:!0});var Oo=r(rs);ga=o(Oo,"SPAN",{});var Po=r(ga);m(Es.$$.fragment,Po),Po.forEach(t),Oo.forEach(t),Ye=d(oe),ba=o(oe,"SPAN",{});var Fo=r(ba);Re=n(Fo,"Other feature types"),Fo.forEach(t),oe.forEach(t),qt=d(s),$s=o(s,"P",{});var ho=r($s);zs=o(ho,"A",{href:!0});var Io=r(zs);We=n(Io,"ClassLabel"),Io.forEach(t),Me=n(ho," data are properly converted to tensors:"),ho.forEach(t),xt=d(s),m(Ds.$$.fragment,s),Ct=d(s),Bs=o(s,"P",{});var No=r(Bs);ze=n(No,"Strings and binary objects are also supported:"),No.forEach(t),At=d(s),m(ks.$$.fragment,s),Ot=d(s),Ks=o(s,"P",{});var So=r(Ks);Be=n(So,"You can also explicitly format certain columns and leave the other columns unformatted:"),So.forEach(t),Pt=d(s),m(Ts.$$.fragment,s),Ft=d(s),Gs=o(s,"P",{});var Ho=r(Gs);Ke=n(Ho,"String and binary objects are unchanged, since PyTorch only supports numbers."),Ho.forEach(t),It=d(s),U=o(s,"P",{});var sa=r(U);Ge=n(sa,"The "),Js=o(sa,"A",{href:!0});var Lo=r(Js);Je=n(Lo,"Image"),Lo.forEach(t),Qe=n(sa," and "),Qs=o(sa,"A",{href:!0});var Uo=r(Qs);Ve=n(Uo,"Audio"),Uo.forEach(t),Xe=n(sa," feature types are also supported:"),sa.forEach(t),Nt=d(s),m(qs.$$.fragment,s),St=d(s),m(xs.$$.fragment,s),Ht=d(s),Q=o(s,"H2",{class:!0});var re=r(Q);ps=o(re,"A",{id:!0,class:!0,href:!0});var Yo=r(ps);ya=o(Yo,"SPAN",{});var Ro=r(ya);m(Cs.$$.fragment,Ro),Ro.forEach(t),Yo.forEach(t),Ze=d(re),ja=o(re,"SPAN",{});var Wo=r(ja);sn=n(Wo,"Data loading"),Wo.forEach(t),re.forEach(t),Lt=d(s),D=o(s,"P",{});var I=r(D);an=n(I,`Although you can load individual samples and batches just by indexing into your dataset, this won\u2019t work if you want
to use Keras methods like `),wa=o(I,"CODE",{});var Mo=r(wa);tn=n(Mo,"fit()"),Mo.forEach(t),en=n(I," and "),va=o(I,"CODE",{});var zo=r(va);nn=n(zo,"predict()"),zo.forEach(t),ln=n(I,`. You could write a generator function that shuffles and loads batches
from your dataset and `),_a=o(I,"CODE",{});var Bo=r(_a);on=n(Bo,"fit()"),Bo.forEach(t),rn=n(I,` on that, but that sounds like a lot of unnecessary work. Instead, if you want to stream
data from your dataset on-the-fly, we recommend converting your dataset to a `),Ea=o(I,"CODE",{});var Ko=r(Ea);pn=n(Ko,"tf.data.Dataset"),Ko.forEach(t),hn=n(I,` using the
`),$a=o(I,"CODE",{});var Go=r($a);dn=n(Go,"to_tf_dataset()"),Go.forEach(t),cn=n(I," method."),I.forEach(t),Ut=d(s),v=o(s,"P",{});var q=r(v);un=n(q,"The "),Da=o(q,"CODE",{});var Jo=r(Da);fn=n(Jo,"tf.data.Dataset"),Jo.forEach(t),mn=n(q,` class covers a wide range of use-cases - it is often created from Tensors in memory, or using a load function to read files on disc
or external storage. The dataset can be transformed arbitrarily with the `),ka=o(q,"CODE",{});var Qo=r(ka);gn=n(Qo,"map()"),Qo.forEach(t),bn=n(q," method, or methods like "),Ta=o(q,"CODE",{});var Vo=r(Ta);yn=n(Vo,"batch()"),Vo.forEach(t),jn=n(q,`
and `),qa=o(q,"CODE",{});var Xo=r(qa);wn=n(Xo,"shuffle()"),Xo.forEach(t),vn=n(q,` can be used to create a dataset that\u2019s ready for training. These methods do not modify the stored data
in any way - instead, the methods build a data pipeline graph that will be executed when the dataset is iterated over,
usually during model training or inference. This is different from the `),xa=o(q,"CODE",{});var Zo=r(xa);_n=n(Zo,"map()"),Zo.forEach(t),En=n(q," method of Hugging Face "),Ca=o(q,"CODE",{});var sr=r(Ca);$n=n(sr,"Dataset"),sr.forEach(t),Dn=n(q,` objects,
which runs the map function immediately and saves the new or changed columns.`),q.forEach(t),Yt=d(s),_=o(s,"P",{});var x=r(_);kn=n(x,"Since the entire data preprocessing pipeline can be compiled in a "),Aa=o(x,"CODE",{});var ar=r(Aa);Tn=n(ar,"tf.data.Dataset"),ar.forEach(t),qn=n(x,`, this approach allows for massively
parallel, asynchronous data loading and training. However, the requirement for graph compilation can be a limitation,
particularly for Hugging Face tokenizers, which are usually not (yet!) compilable as part of a TF graph. As a result,
we usually advise pre-processing the dataset as a Hugging Face dataset, where arbitrary Python functions can be
used, and then converting to `),Oa=o(x,"CODE",{});var tr=r(Oa);xn=n(tr,"tf.data.Dataset"),tr.forEach(t),Cn=n(x," afterwards using "),Pa=o(x,"CODE",{});var er=r(Pa);An=n(er,"to_tf_dataset()"),er.forEach(t),On=n(x,` to get a batched dataset ready for
training. To see examples of this approach, please see the `),As=o(x,"A",{href:!0,rel:!0});var nr=r(As);Pn=n(nr,"examples"),nr.forEach(t),Fn=n(x," or "),Os=o(x,"A",{href:!0,rel:!0});var lr=r(Os);In=n(lr,"notebooks"),lr.forEach(t),Nn=n(x," for "),Fa=o(x,"CODE",{});var or=r(Fa);Sn=n(or,"transformers"),or.forEach(t),Hn=n(x,"."),x.forEach(t),Rt=d(s),V=o(s,"H3",{class:!0});var pe=r(V);is=o(pe,"A",{id:!0,class:!0,href:!0});var rr=r(is);Ia=o(rr,"SPAN",{});var pr=r(Ia);m(Ps.$$.fragment,pr),pr.forEach(t),rr.forEach(t),Ln=d(pe),Vs=o(pe,"SPAN",{});var co=r(Vs);Un=n(co,"Using "),Na=o(co,"CODE",{});var ir=r(Na);Yn=n(ir,"to_tf_dataset()"),ir.forEach(t),co.forEach(t),pe.forEach(t),Wt=d(s),hs=o(s,"P",{});var ie=r(hs);Rn=n(ie,"Using "),Sa=o(ie,"CODE",{});var hr=r(Sa);Wn=n(hr,"to_tf_dataset()"),hr.forEach(t),Mn=n(ie," is straightforward. Once your dataset is preprocessed and ready, simply call it like so:"),ie.forEach(t),Mt=d(s),m(Fs.$$.fragment,s),zt=d(s),F=o(s,"P",{});var fs=r(F);zn=n(fs,"The returned "),Ha=o(fs,"CODE",{});var dr=r(Ha);Bn=n(dr,"tf_ds"),dr.forEach(t),Kn=n(fs," object here is now fully ready to train on, and can be passed directly to "),La=o(fs,"CODE",{});var cr=r(La);Gn=n(cr,"model.fit()"),cr.forEach(t),Jn=n(fs,`. Note
that you set the batch size when creating the dataset, and so you don\u2019t need to specify it when calling `),Ua=o(fs,"CODE",{});var ur=r(Ua);Qn=n(ur,"fit()"),ur.forEach(t),Vn=n(fs,":"),fs.forEach(t),Bt=d(s),m(Is.$$.fragment,s),Kt=d(s),E=o(s,"P",{});var C=r(E);Xn=n(C,"For a full description of the arguments, please see the "),Xs=o(C,"A",{href:!0});var fr=r(Xs);Zn=n(fr,"to_tf_dataset()"),fr.forEach(t),sl=n(C,` documentation. In many cases,
you will also need to add a `),Ya=o(C,"CODE",{});var mr=r(Ya);al=n(mr,"collate_fn"),mr.forEach(t),tl=n(C,` to your call. This is a function that takes multiple elements of the dataset
and combines them into a single batch. When all elements have the same length, the built-in default collator will
suffice, but for more complex tasks a custom collator may be necessary. In particular, many tasks have samples
with varying sequence lengths which will require a `),Ns=o(C,"A",{href:!0,rel:!0});var gr=r(Ns);el=n(gr,"data collator"),gr.forEach(t),nl=n(C,` that can pad batches correctly. You can see examples
of this in the `),Ra=o(C,"CODE",{});var br=r(Ra);ll=n(br,"transformers"),br.forEach(t),ol=n(C," NLP "),Ss=o(C,"A",{href:!0,rel:!0});var yr=r(Ss);rl=n(yr,"examples"),yr.forEach(t),pl=n(C,` and
`),Hs=o(C,"A",{href:!0,rel:!0});var jr=r(Hs);il=n(jr,"notebooks"),jr.forEach(t),hl=n(C,", where variable sequence lengths are very common."),C.forEach(t),Gt=d(s),Y=o(s,"P",{});var aa=r(Y);dl=n(aa,"If you find that loading with "),Wa=o(aa,"CODE",{});var wr=r(Wa);cl=n(wr,"to_tf_dataset"),wr.forEach(t),ul=n(aa," is slow, you can also use the "),Ma=o(aa,"CODE",{});var vr=r(Ma);fl=n(vr,"num_workers"),vr.forEach(t),ml=n(aa,` argument. This spins
up multiple subprocesses to load data in parallel. This feature is recent and still somewhat experimental - please file
an issue if you encounter any bugs while using it!`),aa.forEach(t),Jt=d(s),X=o(s,"H3",{class:!0});var he=r(X);ds=o(he,"A",{id:!0,class:!0,href:!0});var _r=r(ds);za=o(_r,"SPAN",{});var Er=r(za);m(Ls.$$.fragment,Er),Er.forEach(t),_r.forEach(t),gl=d(he),Ba=o(he,"SPAN",{});var $r=r(Ba);bl=n($r,"When to use to_tf_dataset"),$r.forEach(t),he.forEach(t),Qt=d(s),u=o(s,"P",{});var k=r(u);yl=n(k,`The astute reader may have noticed at this point that we have offered two approaches to achieve the same goal - if you
want to pass your dataset to a TensorFlow model, you can either convert the dataset to a `),Ka=o(k,"CODE",{});var Dr=r(Ka);jl=n(Dr,"Tensor"),Dr.forEach(t),wl=n(k," or "),Ga=o(k,"CODE",{});var kr=r(Ga);vl=n(kr,"dict"),kr.forEach(t),_l=n(k," of "),Ja=o(k,"CODE",{});var Tr=r(Ja);El=n(Tr,"Tensors"),Tr.forEach(t),$l=n(k,`
using `),Qa=o(k,"CODE",{});var qr=r(Qa);Dl=n(qr,".with_format('tf')"),qr.forEach(t),kl=n(k,", or you can convert the dataset to a "),Va=o(k,"CODE",{});var xr=r(Va);Tl=n(xr,"tf.data.Dataset"),xr.forEach(t),ql=n(k," with "),Xa=o(k,"CODE",{});var Cr=r(Xa);xl=n(Cr,"to_tf_dataset()"),Cr.forEach(t),Cl=n(k,`. Either of these
can be passed to `),Za=o(k,"CODE",{});var Ar=r(Za);Al=n(Ar,"model.fit()"),Ar.forEach(t),Ol=n(k,", so which should you choose?"),k.forEach(t),Vt=d(s),R=o(s,"P",{});var ta=r(R);Pl=n(ta,"The key thing to recognize is that when you convert the whole dataset to "),st=o(ta,"CODE",{});var Or=r(st);Fl=n(Or,"Tensor"),Or.forEach(t),Il=n(ta,`s, it is static and fully loaded into
RAM. This is simple and convenient, but if any of the following apply, you should probably use `),at=o(ta,"CODE",{});var Pr=r(at);Nl=n(Pr,"to_tf_dataset()"),Pr.forEach(t),Sl=n(ta,`
instead:`),ta.forEach(t),Xt=d(s),W=o(s,"UL",{});var ea=r(W);Us=o(ea,"LI",{});var de=r(Us);Hl=n(de,"Your dataset is too large to fit in RAM. "),tt=o(de,"CODE",{});var Fr=r(tt);Ll=n(Fr,"to_tf_dataset()"),Fr.forEach(t),Ul=n(de,` streams only one batch at a time, so even very large
datasets can be handled with this method.`),de.forEach(t),Yl=d(ea),N=o(ea,"LI",{});var ms=r(N);Rl=n(ms,"You want to apply random transformations using "),et=o(ms,"CODE",{});var Ir=r(et);Wl=n(Ir,"dataset.with_transform()"),Ir.forEach(t),Ml=n(ms," or the "),nt=o(ms,"CODE",{});var Nr=r(nt);zl=n(Nr,"collate_fn"),Nr.forEach(t),Bl=n(ms,`. This is
common in several modalities, such as image augmentations when training vision models, or random masking when training
masked language models. Using `),lt=o(ms,"CODE",{});var Sr=r(lt);Kl=n(Sr,"to_tf_dataset()"),Sr.forEach(t),Gl=n(ms,` will apply those transformations
at the moment when a batch is loaded, which means the same samples will get different augmentations each time
they are loaded. This is usually what you want.`),ms.forEach(t),Jl=d(ea),O=o(ea,"LI",{});var z=r(O);Ql=n(z,`Your data has a variable dimension, such as input texts in NLP that consist of varying
numbers of tokens. When you create a batch with samples with a variable dimension, the standard solution is to
pad the shorter samples to the length of the longest one. When you stream samples from a dataset with `),ot=o(z,"CODE",{});var Hr=r(ot);Vl=n(Hr,"to_tf_dataset"),Hr.forEach(t),Xl=n(z,`,
you can apply this padding to each batch via your `),rt=o(z,"CODE",{});var Lr=r(rt);Zl=n(Lr,"collate_fn"),Lr.forEach(t),so=n(z,`. However, if you want to convert
such a dataset to dense `),pt=o(z,"CODE",{});var Ur=r(pt);ao=n(Ur,"Tensor"),Ur.forEach(t),to=n(z,"s, then you will have to pad samples to the length of the longest sample in "),it=o(z,"EM",{});var Yr=r(it);eo=n(Yr,`the
entire dataset!`),Yr.forEach(t),no=n(z," This can result in huge amounts of padding, which wastes memory and reduces your model\u2019s speed."),z.forEach(t),ea.forEach(t),Zt=d(s),Z=o(s,"H3",{class:!0});var ce=r(Z);cs=o(ce,"A",{id:!0,class:!0,href:!0});var Rr=r(cs);ht=o(Rr,"SPAN",{});var Wr=r(ht);m(Ys.$$.fragment,Wr),Wr.forEach(t),Rr.forEach(t),lo=d(ce),dt=o(ce,"SPAN",{});var Mr=r(dt);oo=n(Mr,"Caveats and limitations"),Mr.forEach(t),ce.forEach(t),se=d(s),us=o(s,"P",{});var ue=r(us);ro=n(ue,"Right now, "),ct=o(ue,"CODE",{});var zr=r(ct);po=n(zr,"to_tf_dataset()"),zr.forEach(t),io=n(ue," always returns a batched dataset - we will add support for unbatched datasets soon!"),ue.forEach(t),this.h()},h(){c(w,"name","hf:doc:metadata"),c(w,"content",JSON.stringify(sp)),c(P,"id","using-datasets-with-tensorflow"),c(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(P,"href","#using-datasets-with-tensorflow"),c($,"class","relative group"),c(ts,"id","dataset-format"),c(ts,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ts,"href","#dataset-format"),c(K,"class","relative group"),c(ls,"id","ndimensional-arrays"),c(ls,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ls,"href","#ndimensional-arrays"),c(G,"class","relative group"),c(rs,"id","other-feature-types"),c(rs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(rs,"href","#other-feature-types"),c(J,"class","relative group"),c(zs,"href","/docs/datasets/v2.9.0/en/package_reference/main_classes#datasets.ClassLabel"),c(Js,"href","/docs/datasets/v2.9.0/en/package_reference/main_classes#datasets.Image"),c(Qs,"href","/docs/datasets/v2.9.0/en/package_reference/main_classes#datasets.Audio"),c(ps,"id","data-loading"),c(ps,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ps,"href","#data-loading"),c(Q,"class","relative group"),c(As,"href","https://github.com/huggingface/transformers/tree/main/examples"),c(As,"rel","nofollow"),c(Os,"href","https://huggingface.co/docs/transformers/notebooks"),c(Os,"rel","nofollow"),c(is,"id","using-totfdataset"),c(is,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(is,"href","#using-totfdataset"),c(V,"class","relative group"),c(Xs,"href","/docs/datasets/v2.9.0/en/package_reference/main_classes#datasets.Dataset.to_tf_dataset"),c(Ns,"href","https://huggingface.co/docs/transformers/main/en/main_classes/data_collator"),c(Ns,"rel","nofollow"),c(Ss,"href","https://github.com/huggingface/transformers/tree/main/examples"),c(Ss,"rel","nofollow"),c(Hs,"href","https://huggingface.co/docs/transformers/notebooks"),c(Hs,"rel","nofollow"),c(ds,"id","when-to-use-totfdataset"),c(ds,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ds,"href","#when-to-use-totfdataset"),c(X,"class","relative group"),c(cs,"id","caveats-and-limitations"),c(cs,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(cs,"href","#caveats-and-limitations"),c(Z,"class","relative group")},m(s,p){a(document.head,w),i(s,ss,p),i(s,$,p),a($,P),a(P,B),g(A,B,null),a($,H),a($,as),a(as,fe),i(s,ft,p),i(s,T,p),a(T,me),a(T,na),a(na,ge),a(T,be),a(T,la),a(la,ye),a(T,je),a(T,oa),a(oa,we),a(T,ve),a(T,ra),a(ra,_e),a(T,Ee),i(s,mt,p),i(s,K,p),a(K,ts),a(ts,pa),g(bs,pa,null),a(K,$e),a(K,ia),a(ia,De),i(s,gt,p),i(s,Ws,p),a(Ws,ke),i(s,bt,p),i(s,es,p),a(es,Te),a(es,ha),a(ha,qe),a(es,xe),i(s,yt,p),g(ys,s,p),i(s,jt,p),g(ns,s,p),i(s,wt,p),i(s,L,p),a(L,Ce),a(L,da),a(da,Ae),a(L,Oe),a(L,ca),a(ca,Pe),a(L,Fe),i(s,vt,p),g(js,s,p),i(s,_t,p),i(s,G,p),a(G,ls),a(ls,ua),g(ws,ua,null),a(G,Ie),a(G,fa),a(fa,Ne),i(s,Et,p),i(s,os,p),a(os,Se),a(os,ma),a(ma,He),a(os,Le),i(s,$t,p),g(vs,s,p),i(s,Dt,p),i(s,Ms,p),a(Ms,Ue),i(s,kt,p),g(_s,s,p),i(s,Tt,p),i(s,J,p),a(J,rs),a(rs,ga),g(Es,ga,null),a(J,Ye),a(J,ba),a(ba,Re),i(s,qt,p),i(s,$s,p),a($s,zs),a(zs,We),a($s,Me),i(s,xt,p),g(Ds,s,p),i(s,Ct,p),i(s,Bs,p),a(Bs,ze),i(s,At,p),g(ks,s,p),i(s,Ot,p),i(s,Ks,p),a(Ks,Be),i(s,Pt,p),g(Ts,s,p),i(s,Ft,p),i(s,Gs,p),a(Gs,Ke),i(s,It,p),i(s,U,p),a(U,Ge),a(U,Js),a(Js,Je),a(U,Qe),a(U,Qs),a(Qs,Ve),a(U,Xe),i(s,Nt,p),g(qs,s,p),i(s,St,p),g(xs,s,p),i(s,Ht,p),i(s,Q,p),a(Q,ps),a(ps,ya),g(Cs,ya,null),a(Q,Ze),a(Q,ja),a(ja,sn),i(s,Lt,p),i(s,D,p),a(D,an),a(D,wa),a(wa,tn),a(D,en),a(D,va),a(va,nn),a(D,ln),a(D,_a),a(_a,on),a(D,rn),a(D,Ea),a(Ea,pn),a(D,hn),a(D,$a),a($a,dn),a(D,cn),i(s,Ut,p),i(s,v,p),a(v,un),a(v,Da),a(Da,fn),a(v,mn),a(v,ka),a(ka,gn),a(v,bn),a(v,Ta),a(Ta,yn),a(v,jn),a(v,qa),a(qa,wn),a(v,vn),a(v,xa),a(xa,_n),a(v,En),a(v,Ca),a(Ca,$n),a(v,Dn),i(s,Yt,p),i(s,_,p),a(_,kn),a(_,Aa),a(Aa,Tn),a(_,qn),a(_,Oa),a(Oa,xn),a(_,Cn),a(_,Pa),a(Pa,An),a(_,On),a(_,As),a(As,Pn),a(_,Fn),a(_,Os),a(Os,In),a(_,Nn),a(_,Fa),a(Fa,Sn),a(_,Hn),i(s,Rt,p),i(s,V,p),a(V,is),a(is,Ia),g(Ps,Ia,null),a(V,Ln),a(V,Vs),a(Vs,Un),a(Vs,Na),a(Na,Yn),i(s,Wt,p),i(s,hs,p),a(hs,Rn),a(hs,Sa),a(Sa,Wn),a(hs,Mn),i(s,Mt,p),g(Fs,s,p),i(s,zt,p),i(s,F,p),a(F,zn),a(F,Ha),a(Ha,Bn),a(F,Kn),a(F,La),a(La,Gn),a(F,Jn),a(F,Ua),a(Ua,Qn),a(F,Vn),i(s,Bt,p),g(Is,s,p),i(s,Kt,p),i(s,E,p),a(E,Xn),a(E,Xs),a(Xs,Zn),a(E,sl),a(E,Ya),a(Ya,al),a(E,tl),a(E,Ns),a(Ns,el),a(E,nl),a(E,Ra),a(Ra,ll),a(E,ol),a(E,Ss),a(Ss,rl),a(E,pl),a(E,Hs),a(Hs,il),a(E,hl),i(s,Gt,p),i(s,Y,p),a(Y,dl),a(Y,Wa),a(Wa,cl),a(Y,ul),a(Y,Ma),a(Ma,fl),a(Y,ml),i(s,Jt,p),i(s,X,p),a(X,ds),a(ds,za),g(Ls,za,null),a(X,gl),a(X,Ba),a(Ba,bl),i(s,Qt,p),i(s,u,p),a(u,yl),a(u,Ka),a(Ka,jl),a(u,wl),a(u,Ga),a(Ga,vl),a(u,_l),a(u,Ja),a(Ja,El),a(u,$l),a(u,Qa),a(Qa,Dl),a(u,kl),a(u,Va),a(Va,Tl),a(u,ql),a(u,Xa),a(Xa,xl),a(u,Cl),a(u,Za),a(Za,Al),a(u,Ol),i(s,Vt,p),i(s,R,p),a(R,Pl),a(R,st),a(st,Fl),a(R,Il),a(R,at),a(at,Nl),a(R,Sl),i(s,Xt,p),i(s,W,p),a(W,Us),a(Us,Hl),a(Us,tt),a(tt,Ll),a(Us,Ul),a(W,Yl),a(W,N),a(N,Rl),a(N,et),a(et,Wl),a(N,Ml),a(N,nt),a(nt,zl),a(N,Bl),a(N,lt),a(lt,Kl),a(N,Gl),a(W,Jl),a(W,O),a(O,Ql),a(O,ot),a(ot,Vl),a(O,Xl),a(O,rt),a(rt,Zl),a(O,so),a(O,pt),a(pt,ao),a(O,to),a(O,it),a(it,eo),a(O,no),i(s,Zt,p),i(s,Z,p),a(Z,cs),a(cs,ht),g(Ys,ht,null),a(Z,lo),a(Z,dt),a(dt,oo),i(s,se,p),i(s,us,p),a(us,ro),a(us,ct),a(ct,po),a(us,io),ae=!0},p(s,[p]){const Rs={};p&2&&(Rs.$$scope={dirty:p,ctx:s}),ns.$set(Rs)},i(s){ae||(b(A.$$.fragment,s),b(bs.$$.fragment,s),b(ys.$$.fragment,s),b(ns.$$.fragment,s),b(js.$$.fragment,s),b(ws.$$.fragment,s),b(vs.$$.fragment,s),b(_s.$$.fragment,s),b(Es.$$.fragment,s),b(Ds.$$.fragment,s),b(ks.$$.fragment,s),b(Ts.$$.fragment,s),b(qs.$$.fragment,s),b(xs.$$.fragment,s),b(Cs.$$.fragment,s),b(Ps.$$.fragment,s),b(Fs.$$.fragment,s),b(Is.$$.fragment,s),b(Ls.$$.fragment,s),b(Ys.$$.fragment,s),ae=!0)},o(s){y(A.$$.fragment,s),y(bs.$$.fragment,s),y(ys.$$.fragment,s),y(ns.$$.fragment,s),y(js.$$.fragment,s),y(ws.$$.fragment,s),y(vs.$$.fragment,s),y(_s.$$.fragment,s),y(Es.$$.fragment,s),y(Ds.$$.fragment,s),y(ks.$$.fragment,s),y(Ts.$$.fragment,s),y(qs.$$.fragment,s),y(xs.$$.fragment,s),y(Cs.$$.fragment,s),y(Ps.$$.fragment,s),y(Fs.$$.fragment,s),y(Is.$$.fragment,s),y(Ls.$$.fragment,s),y(Ys.$$.fragment,s),ae=!1},d(s){t(w),s&&t(ss),s&&t($),j(A),s&&t(ft),s&&t(T),s&&t(mt),s&&t(K),j(bs),s&&t(gt),s&&t(Ws),s&&t(bt),s&&t(es),s&&t(yt),j(ys,s),s&&t(jt),j(ns,s),s&&t(wt),s&&t(L),s&&t(vt),j(js,s),s&&t(_t),s&&t(G),j(ws),s&&t(Et),s&&t(os),s&&t($t),j(vs,s),s&&t(Dt),s&&t(Ms),s&&t(kt),j(_s,s),s&&t(Tt),s&&t(J),j(Es),s&&t(qt),s&&t($s),s&&t(xt),j(Ds,s),s&&t(Ct),s&&t(Bs),s&&t(At),j(ks,s),s&&t(Ot),s&&t(Ks),s&&t(Pt),j(Ts,s),s&&t(Ft),s&&t(Gs),s&&t(It),s&&t(U),s&&t(Nt),j(qs,s),s&&t(St),j(xs,s),s&&t(Ht),s&&t(Q),j(Cs),s&&t(Lt),s&&t(D),s&&t(Ut),s&&t(v),s&&t(Yt),s&&t(_),s&&t(Rt),s&&t(V),j(Ps),s&&t(Wt),s&&t(hs),s&&t(Mt),j(Fs,s),s&&t(zt),s&&t(F),s&&t(Bt),j(Is,s),s&&t(Kt),s&&t(E),s&&t(Gt),s&&t(Y),s&&t(Jt),s&&t(X),j(Ls),s&&t(Qt),s&&t(u),s&&t(Vt),s&&t(R),s&&t(Xt),s&&t(W),s&&t(Zt),s&&t(Z),j(Ys),s&&t(se),s&&t(us)}}}const sp={local:"using-datasets-with-tensorflow",sections:[{local:"dataset-format",title:"Dataset format"},{local:"ndimensional-arrays",title:"N-dimensional arrays"},{local:"other-feature-types",title:"Other feature types"},{local:"data-loading",sections:[{local:"using-totfdataset",title:"Using `to_tf_dataset()`"},{local:"when-to-use-totfdataset",title:"When to use to_tf_dataset"},{local:"caveats-and-limitations",title:"Caveats and limitations"}],title:"Data loading"}],title:"Using Datasets with TensorFlow"};function ap(ut){return Qr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class op extends Br{constructor(w){super();Kr(this,w,ap,Zr,Gr,{})}}export{op as default,sp as metadata};
